// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package freeje_admin

import (
	context "context"
	api "gitlab.com/BetaCompany/Freeje/sdk/go/api"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// LCRClient is the client API for LCR service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type LCRClient interface {
	//
	// Обновить метаданный рейта.
	Update(ctx context.Context, in *VoipGatewayRate, opts ...grpc.CallOption) (*VoipGatewayRate, error)
	//
	// Удалить метаданные рейта.
	Delete(ctx context.Context, in *VoipGatewayRate, opts ...grpc.CallOption) (*VoipGatewayRate, error)
	//
	// Получить детали рейта
	Get(ctx context.Context, in *VoipGatewayRate, opts ...grpc.CallOption) (*VoipGatewayRate, error)
	//
	// Получить список заведенных рейтов.
	List(ctx context.Context, in *api.SearchFilter, opts ...grpc.CallOption) (LCR_ListClient, error)
	//
	// Обновить данные рейта по префиксу.
	UpdatePrefix(ctx context.Context, in *VoipGatewayPrefixRate, opts ...grpc.CallOption) (*VoipGatewayPrefixRate, error)
	//
	// Удалить префикс.
	DeletePrefix(ctx context.Context, in *VoipGatewayPrefixRate, opts ...grpc.CallOption) (*VoipGatewayPrefixRate, error)
	//
	// Получить список префиксов по рейту.
	ListPrefix(ctx context.Context, in *VoipGatewayRate, opts ...grpc.CallOption) (LCR_ListPrefixClient, error)
}

type lCRClient struct {
	cc grpc.ClientConnInterface
}

func NewLCRClient(cc grpc.ClientConnInterface) LCRClient {
	return &lCRClient{cc}
}

func (c *lCRClient) Update(ctx context.Context, in *VoipGatewayRate, opts ...grpc.CallOption) (*VoipGatewayRate, error) {
	out := new(VoipGatewayRate)
	err := c.cc.Invoke(ctx, "/com.freeje.api.admin.LCR/Update", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *lCRClient) Delete(ctx context.Context, in *VoipGatewayRate, opts ...grpc.CallOption) (*VoipGatewayRate, error) {
	out := new(VoipGatewayRate)
	err := c.cc.Invoke(ctx, "/com.freeje.api.admin.LCR/Delete", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *lCRClient) Get(ctx context.Context, in *VoipGatewayRate, opts ...grpc.CallOption) (*VoipGatewayRate, error) {
	out := new(VoipGatewayRate)
	err := c.cc.Invoke(ctx, "/com.freeje.api.admin.LCR/Get", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *lCRClient) List(ctx context.Context, in *api.SearchFilter, opts ...grpc.CallOption) (LCR_ListClient, error) {
	stream, err := c.cc.NewStream(ctx, &LCR_ServiceDesc.Streams[0], "/com.freeje.api.admin.LCR/List", opts...)
	if err != nil {
		return nil, err
	}
	x := &lCRListClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type LCR_ListClient interface {
	Recv() (*VoipGatewayRate, error)
	grpc.ClientStream
}

type lCRListClient struct {
	grpc.ClientStream
}

func (x *lCRListClient) Recv() (*VoipGatewayRate, error) {
	m := new(VoipGatewayRate)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *lCRClient) UpdatePrefix(ctx context.Context, in *VoipGatewayPrefixRate, opts ...grpc.CallOption) (*VoipGatewayPrefixRate, error) {
	out := new(VoipGatewayPrefixRate)
	err := c.cc.Invoke(ctx, "/com.freeje.api.admin.LCR/UpdatePrefix", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *lCRClient) DeletePrefix(ctx context.Context, in *VoipGatewayPrefixRate, opts ...grpc.CallOption) (*VoipGatewayPrefixRate, error) {
	out := new(VoipGatewayPrefixRate)
	err := c.cc.Invoke(ctx, "/com.freeje.api.admin.LCR/DeletePrefix", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *lCRClient) ListPrefix(ctx context.Context, in *VoipGatewayRate, opts ...grpc.CallOption) (LCR_ListPrefixClient, error) {
	stream, err := c.cc.NewStream(ctx, &LCR_ServiceDesc.Streams[1], "/com.freeje.api.admin.LCR/ListPrefix", opts...)
	if err != nil {
		return nil, err
	}
	x := &lCRListPrefixClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type LCR_ListPrefixClient interface {
	Recv() (*VoipGatewayPrefixRate, error)
	grpc.ClientStream
}

type lCRListPrefixClient struct {
	grpc.ClientStream
}

func (x *lCRListPrefixClient) Recv() (*VoipGatewayPrefixRate, error) {
	m := new(VoipGatewayPrefixRate)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

// LCRServer is the server API for LCR service.
// All implementations should embed UnimplementedLCRServer
// for forward compatibility
type LCRServer interface {
	//
	// Обновить метаданный рейта.
	Update(context.Context, *VoipGatewayRate) (*VoipGatewayRate, error)
	//
	// Удалить метаданные рейта.
	Delete(context.Context, *VoipGatewayRate) (*VoipGatewayRate, error)
	//
	// Получить детали рейта
	Get(context.Context, *VoipGatewayRate) (*VoipGatewayRate, error)
	//
	// Получить список заведенных рейтов.
	List(*api.SearchFilter, LCR_ListServer) error
	//
	// Обновить данные рейта по префиксу.
	UpdatePrefix(context.Context, *VoipGatewayPrefixRate) (*VoipGatewayPrefixRate, error)
	//
	// Удалить префикс.
	DeletePrefix(context.Context, *VoipGatewayPrefixRate) (*VoipGatewayPrefixRate, error)
	//
	// Получить список префиксов по рейту.
	ListPrefix(*VoipGatewayRate, LCR_ListPrefixServer) error
}

// UnimplementedLCRServer should be embedded to have forward compatible implementations.
type UnimplementedLCRServer struct {
}

func (UnimplementedLCRServer) Update(context.Context, *VoipGatewayRate) (*VoipGatewayRate, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Update not implemented")
}
func (UnimplementedLCRServer) Delete(context.Context, *VoipGatewayRate) (*VoipGatewayRate, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Delete not implemented")
}
func (UnimplementedLCRServer) Get(context.Context, *VoipGatewayRate) (*VoipGatewayRate, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Get not implemented")
}
func (UnimplementedLCRServer) List(*api.SearchFilter, LCR_ListServer) error {
	return status.Errorf(codes.Unimplemented, "method List not implemented")
}
func (UnimplementedLCRServer) UpdatePrefix(context.Context, *VoipGatewayPrefixRate) (*VoipGatewayPrefixRate, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UpdatePrefix not implemented")
}
func (UnimplementedLCRServer) DeletePrefix(context.Context, *VoipGatewayPrefixRate) (*VoipGatewayPrefixRate, error) {
	return nil, status.Errorf(codes.Unimplemented, "method DeletePrefix not implemented")
}
func (UnimplementedLCRServer) ListPrefix(*VoipGatewayRate, LCR_ListPrefixServer) error {
	return status.Errorf(codes.Unimplemented, "method ListPrefix not implemented")
}

// UnsafeLCRServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to LCRServer will
// result in compilation errors.
type UnsafeLCRServer interface {
	mustEmbedUnimplementedLCRServer()
}

func RegisterLCRServer(s grpc.ServiceRegistrar, srv LCRServer) {
	s.RegisterService(&LCR_ServiceDesc, srv)
}

func _LCR_Update_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(VoipGatewayRate)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(LCRServer).Update(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.admin.LCR/Update",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(LCRServer).Update(ctx, req.(*VoipGatewayRate))
	}
	return interceptor(ctx, in, info, handler)
}

func _LCR_Delete_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(VoipGatewayRate)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(LCRServer).Delete(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.admin.LCR/Delete",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(LCRServer).Delete(ctx, req.(*VoipGatewayRate))
	}
	return interceptor(ctx, in, info, handler)
}

func _LCR_Get_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(VoipGatewayRate)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(LCRServer).Get(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.admin.LCR/Get",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(LCRServer).Get(ctx, req.(*VoipGatewayRate))
	}
	return interceptor(ctx, in, info, handler)
}

func _LCR_List_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(api.SearchFilter)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(LCRServer).List(m, &lCRListServer{stream})
}

type LCR_ListServer interface {
	Send(*VoipGatewayRate) error
	grpc.ServerStream
}

type lCRListServer struct {
	grpc.ServerStream
}

func (x *lCRListServer) Send(m *VoipGatewayRate) error {
	return x.ServerStream.SendMsg(m)
}

func _LCR_UpdatePrefix_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(VoipGatewayPrefixRate)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(LCRServer).UpdatePrefix(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.admin.LCR/UpdatePrefix",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(LCRServer).UpdatePrefix(ctx, req.(*VoipGatewayPrefixRate))
	}
	return interceptor(ctx, in, info, handler)
}

func _LCR_DeletePrefix_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(VoipGatewayPrefixRate)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(LCRServer).DeletePrefix(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.admin.LCR/DeletePrefix",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(LCRServer).DeletePrefix(ctx, req.(*VoipGatewayPrefixRate))
	}
	return interceptor(ctx, in, info, handler)
}

func _LCR_ListPrefix_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(VoipGatewayRate)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(LCRServer).ListPrefix(m, &lCRListPrefixServer{stream})
}

type LCR_ListPrefixServer interface {
	Send(*VoipGatewayPrefixRate) error
	grpc.ServerStream
}

type lCRListPrefixServer struct {
	grpc.ServerStream
}

func (x *lCRListPrefixServer) Send(m *VoipGatewayPrefixRate) error {
	return x.ServerStream.SendMsg(m)
}

// LCR_ServiceDesc is the grpc.ServiceDesc for LCR service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var LCR_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "com.freeje.api.admin.LCR",
	HandlerType: (*LCRServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Update",
			Handler:    _LCR_Update_Handler,
		},
		{
			MethodName: "Delete",
			Handler:    _LCR_Delete_Handler,
		},
		{
			MethodName: "Get",
			Handler:    _LCR_Get_Handler,
		},
		{
			MethodName: "UpdatePrefix",
			Handler:    _LCR_UpdatePrefix_Handler,
		},
		{
			MethodName: "DeletePrefix",
			Handler:    _LCR_DeletePrefix_Handler,
		},
	},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "List",
			Handler:       _LCR_List_Handler,
			ServerStreams: true,
		},
		{
			StreamName:    "ListPrefix",
			Handler:       _LCR_ListPrefix_Handler,
			ServerStreams: true,
		},
	},
	Metadata: "admin/lcr.proto",
}
